<?php defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: webcomment.php,v 1.5 2009/11/21 22:44:02 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');

class LinkDirectory2ModelWebcomment extends JModel {
	
	private $_rev_id = null;
	private $_data = null;

	/**
	 *
	 */
	public function __construct() {
		parent::__construct();
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$edit = JRequest::getVar('edit',true);
		if($edit) {
			$this->setId((int)$array[0]);
		}
	}

	/**
	 *
	 */
	private function setId($id) {
		$this->_rev_id	= $id;
		$this->_data	= null;
	}

	/**
	 * Liefert alle Daten eines Kommentars inkl. einige Daten des Users und Links 
	 *     u.name AS username (User)
	 *     l.title AS link_title (Link)
	 */
	public function &getData()	{
		if (!$this->_loadData()) {
			$this->_initData();
		}
		return $this->_data;
	}

	/**
	 *
	 */
	public function isCheckedOut( $uid=0 ) {
		if ($this->_loadData()) {
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	/**
	 *
	 */
	public function checkin() {
		if ($this->_rev_id) {
			$weblink = & $this->getTable();
			if(! $weblink->checkin($this->_rev_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			return true;
		}
		return true;
	}

	/**
	 *
	 */
	public function checkout($uid = null) {
		if ($this->_rev_id) {
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			$webcomment = & $this->getTable();
			if(!$webcomment->checkout($uid, $this->_rev_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			return true;
		}
		return false;
	}

	/**
	 *
	 */
	public function store($data) {
		$row =& $this->getTable();
		$row->bind($data);
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->check()) {
			$this->setError($row->getError());
			return false;
		}
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}

	/**
	 *
	 */
	public function delete($cid = array()) {
		$result = false;
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__ldcomment '
					. ' WHERE rev_id IN ( '.$cids.' )'
				;
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	/**
	 *
	 */
	public function approved($cid = array(), $publish = 1) {
		$user 	=& JFactory::getUser();
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'UPDATE #__ldcomment'
				. ' SET rev_approved = '.(int) $publish
				. ' WHERE rev_id IN ( '.$cids.' )'
				. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}
	
	/**
	 * Liefert eine Liste mit allen Links (id und titel), sortiert nach titel. Der Titel
	 * ist dabei gekurzt auf 150 Zeichen. 
	 * @return Liste mit allen Links
	 */
	public function &getAllLinks(){	
		$query = 'SELECT a.id AS value, substring(a.title,1,150) as text '
			. ' FROM #__ldlinks AS a '
			. ' ORDER BY a.title '
			;	
		$allLinks =  $this->_getList($query );
		return $allLinks;
	}

	/**
	 *
	 */
	private function &_loadData() { 
		if (empty($this->_data)) {
			$query = ' SELECT a.*, l.title AS link_title , u.name AS username '
					. ' FROM #__ldcomment AS a '
					. ' LEFT JOIN #__ldlinks AS l ON l.id = a.link_id '
					. ' LEFT JOIN #__users AS u on u.id = a.user_id '
					. ' WHERE a.rev_id = '.(int) $this->_rev_id;
					;			
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}

	/**
	 *
	 */
	private function &_initData() {
		if (empty($this->_data)) {
			$webcomment = new stdClass();
			$webcomment->rev_id = 0;
			$webcomment->link_id = 0;
			$webcomment->user_id = null;
			$webcomment->type = null;
			$webcomment->guest_name = null;
			$webcomment->rev_title = null;
			$webcomment->rev_text = null;
			$webcomment->rev_date = null;
			$webcomment->rev_approved = null;
			$webcomment->published = null;
			$webcomment->checked_out = null;
			$webcomment->checked_out_time = null;
			$webcomment->link_title = null;
			$this->_data = $webcomment;
			return (boolean) $this->_data;
		}
		return true;
	}
}