<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: RatingHtmlUtils.php,v 1.5 2009/11/24 23:25:15 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';

class RatingHtmlUtils {
	const MAX_STARS = 5;
	
	/**
	 * Liefert das HTML zum Darstellen eines Star-Images.
	 *
	 * @param String $imageName Name des Star-Image (ohne Pfad)
	 * @return HTML-Code für das Image
	 */
	private static function getHtmlForStar($imageName){
		return '<img src="'.JURI::base().'/components/com_linkdirectory2/images/'.$imageName.'"/>';
	}

	/**
	 * HTML für self::MAX_STARS Sternen entsprechend der Bewertung.
	 *
	 * @param int $rating Bewertung zwischen 0 ...5
	 * @param int $totalVotes Anzahl der Bewertungen
	 * @return HTML mit self::MAX_STARS Sternen
	 */
	public static function show($rating, $totalVotes) {
		$_ld = new LDConfig();
		$star = round($rating, 0);
		$star = $star > self::MAX_STARS ? self::MAX_STARS: $star;
		$html = '';
		// display votes after minrate votes
		if ($totalVotes < $_ld->minrate ) {
			for( $i=0; $i<self::MAX_STARS; $i++) {
				$html .= RatingHtmlUtils::getHtmlForStar('star_00.png');
			}
		} else {
			// Print starts
			for( $i=0; $i<$star; $i++) {
				$html .= RatingHtmlUtils::getHtmlForStar('star_10.png');
			}

			// Print blank star
			for( $i=$star; $i<self::MAX_STARS; $i++) {
				$html .= RatingHtmlUtils::getHtmlForStar('star_00.png');
			}
		}
		return $html;
	}
}
?>