<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: ViewUtils.php,v 1.4 2009/12/01 19:21:47 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class ViewUtils {
	
	/**
	 * Liefert JParameter des aktiven Menü-Eintrages inkl. ggf. gesetzem Property 'page_title'.  
	 *
	 * @param  $row Weblink
	 * @return JParameter mit allen Menü-Paramtern inkl. ggf. gesetztem Property page_title 
	 */
	public static function &setPageTitleForLink(&$rowWeblink){
		$params=self::getPageTitleFromMenu();
		$document =& JFactory::getDocument();
		$document->setTitle( self::buildLinkPageTitleForHtmlHead($params,$rowWeblink) );
		return $params;
	}
	
	/**
	 * Liefert JParameter des aktiven Menü-Eintrages inkl. ggf. gesetzem Property 'page_title'.  
	 *
	 * @param  $row Weblink
	 * @return JParameter mit allen Menü-Paramtern inkl. ggf. gesetztem Property page_title 
	 */
	public static function &setPageTitleForCategories(&$parentCategoryTitle){
		$params=self::getPageTitleFromMenu();
		$document =& JFactory::getDocument();
		$document->setTitle( self::buildCategoiesPageTitleForHtmlHead($params,$parentCategoryTitle));
		return $params;
	}
	
	/**
	 * Liefert in Abhänigkeit  von 'RootLabelType' des aktiven Menüs den Text für
	 * das Root-Element  im Pathway.
	 * 
	 * @return String Label für das Pathway-Root-Element
	 */
	public static function getRootElementLabel(){
		global $mainframe;
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
		$menu_params = new JParameter($menu->params);
		$rootLabelTyp = $menu_params->get('RootLabelType');
		switch ($rootLabelTyp){
			case 0:		// Konfiguration
				require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
				$ld = new LDConfig();
				return $ld->rootPathWay;
			case 1:		// RootLabelText aus Menü
				return $menu_params->get('RootLabelText');				
			case 2:		// None
				return '';
			default:	// Global
				return JText::_('LD PATHWAY ROOT LABEL');
		}	
	}
	
	private static function &buildLinkPageTitleForHtmlHead(&$params,&$rowWeblink){
		$title = $params->get( 'page_title' );
		$title = $title . ' - ' . $rowWeblink->cat_title . ' - ' . JText::_('LD WEBLINK PAGE TITLE') .' ' . $rowWeblink->title;
		return $title; 
	}
	
	private static function &buildCategoiesPageTitleForHtmlHead(&$params,&$parentCategoryTitle){
		$title = $params->get( 'page_title' );
		if ($parentCategoryTitle != null ) {
			$title = $title . ' - ' . $parentCategoryTitle ;
		} 
		return $title; 
	}
	
	private static function &getPageTitleFromMenu(){
		global $mainframe;
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
		$params = &$mainframe->getParams();

		$show_page_title = false;
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );
			if ($menu_params->get( 'show_page_title')) {
				$show_page_title=true;
			}
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	JText::_( 'LINK DIRECTORY 2 PAGE TITLE' ));
			}
		} else {
			$params->set('page_title',	JText::_( 'LINK DIRECTORY 2  PAGE TITLE') );
		}
		return $params;
	}
}

?>