<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: category.php,v 1.6 2009/11/22 21:15:23 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.model' );
require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');

class LinkDirectory2ModelCategory extends JModel {
	private $_catid = null;

	private $_category = null;
	private $_totalLinks = null;
	private $_totalSubCategories = null;
	private $_queryAllLinks = null;
	private $_queryAllSubCategories = null;
	
	public function __construct($cid = null){
		parent::__construct();
		if ($cid == null){
			$id = JRequest::getInt( 'catid', 0, 'get' );
		} else {
			$id = intval($cid);
		}
		$this->setId((int)$id);
	}
	
	public function setId($id){
		$this->_catid	    = $id;
		$this->_category	= null;
		$this->_totalLinks = null;
		$this->_totalSubCategories = null;
		$this->_queryAllLinks = null;
		$this->_queryAllSubCategories = null;
	}
	
	/**
	 * @param cid int Kategorie-Id (optinal)
	 */
	public function &getData($cid = null) {
		if ($cid == null){
			$_catid = JRequest::getInt( 'catid', 0, 'get' );
		} else {
			$_catid = intval($cid);
		}

		$db = &JFactory::getDBO();
		if (!$this->_category){
			$query = "SELECT * FROM #__ldcats"
			. " WHERE published = 1"
			. " AND id = $_catid"
			;
			$db->setQuery( $query );
			$this->_categories =$db->loadObjectList();
		}
		return $this->_category;
	}

	public function getTotalLinks() {
		if (!$this->_totalLinks) {
			$query = $this->buildAllLinks();
			$this->_totalLinks = $this->_getListCount($query);
		}
		return $this->_totalLinks;
	}

	public function getTotalSubCategories() {
		if (!$this->_totalSubCategories) {
			$query = $this->buildAllSubCategories();
			$this->_totalSubCategories = $this->_getListCount($query);
		}
		return $this->_totalSubCategories;
	}

	private function buildAllLinks() {
		if (!$this->_queryAllLinks) {
			$search = $this->_catid;
			$this->_queryAllLinks = "SELECT * FROM #__ldlinks l ";
			if ($search != '') {
				$search = $this->_db->getEscaped( $search, true );
				$this->_queryAllLinks .= " WHERE l.published = 1 AND l.catid = $search";
			}
		}
		return $this->_queryAllLinks;
	}

	private function buildAllSubCategories() {
		if (!$this->_queryAllSubCategories) {
			$search = $this->_catid;
			$this->_queryAllSubCategories = "SELECT * FROM #__ldcats c ";
			if ($search != '') {
				$search = $this->_db->getEscaped( $search, true );
				$this->_queryAllSubCategories .= " WHERE c.published = 1 AND c.parent_id = $search";
			}
		}
		return $this->_queryAllSubCategories;
	}	
}
