<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: log.php,v 1.2 2009/11/22 21:15:23 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.model' );

class LinkDirectory2ModelLog extends JModel {
	private $_data = null;
	private $_actionType = null;
	public static $comment = 'comment';
	public static $vote = 'vote';
	
	/**
	 * Wenn $actionType null bzw. nicht angegeben wird, so wird versucht, den Type aus dem Request
	 * 'log_type' zu ermitteln.
	 *
	 * @param String $actionType log_type, z.Z. werden 'comment' und 'vote' unterstützt
	 */
	public function __construct($actionType=null) {
		parent::__construct();
		if ($actionType === null){
			$this->setActionType(JRequest::getString('log_type',''));
		} else {
			$this->setActionType($actionType);
		}
	}
	
	private function setActionType($actionType){
		$this->_actionType = $actionType;	
	}
	
	private function getActionType(){
		return $this->_actionType;
	}
	
	/**
	 * Liefert alle Log-Eintäge zu einem Link. 
	 * 
	 * Paramter aus dem Request:
	 * <ol> 
	 * <li>id</li>
	 * <li>log_type</li>
	 * </ol>
	 *
	 * @return Liste mit allen Log-Einträgen eines Links
	 */
	public function &getData() {
		$id = JRequest::getInt('id',0);
		
		if (empty($this->_data)) {
			$query = "SELECT * FROM #__ldlog where link_id = $id and log_type = $log_type" ;
			$this->_data = $this->_getList($query);
		}
		return $this->_data;
	}

	/**
	 * Aktualisert das Log für die Aktion $action und dem Link mit der Id $id.
	 * Die IP-Adresse des Clients wird via getenv('REMOTE_ADDR') ermittelt. 
	 * 
	 * @param int $id Id des Links
	 * @param String $action Aktion
	 * @return true, wenn erfolgreich, sonst false
	 */
	public function updateLog($id,$action){
		$id = intval($id);
		$vote_ip = getenv( 'REMOTE_ADDR' );
		
		$user = &JFactory::getUser();
		$now = $this->now();

		// TODO Wenn eine weitere Anfrage  von der selben IP kommt, wird es immer fehl schlagen. Besser ist es,
		// den Log-Eintrag nach einiger Zeit verfallen zu lasssn. Stichwort dynamische IP.
		$query =  "INSERT INTO #__ldlog "
		.		"( `log_ip` , `log_type`, `user_id` , `log_date` , `link_id` )"
		.	"VALUES ( '$vote_ip', '$action', '$user->id', '$now', '$id')";
		$this->_db->setQuery($query);
		if (!$this->_db->query()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
	}
	
	private function now(){
		$offset = & JFactory::getApplication()->getCfg('offset');
		$now = date( "Y-m-d H:i:s", time() + $offset*60*60);
		return $now;
	}
	
	private function lastValidLogDate(){
		$minHourBetweenToAcktion=2;
		$offset = & JFactory::getApplication()->getCfg('offset');
		$lastValidLogDate = date( "Y-m-d H:i:s", time() + ($offset - $minHourBetweenToAcktion) *60*60);
		return $lastValidLogDate;
	}
	
	/**
	 * Liefert true, wenn User schon einen entsprechenden Logeintrag für 
	 * den jeweiligen Link hat, sonst false.
	 * @param int $id
	 * @param String $action Aktion, z.Z. comment und vote zulässig
	 *
	 */
	public function &getHasUserLogEntryForLink($id, $action = null){
		$offset = & JFactory::getApplication()->getCfg('offset');

		$vote_ip = getenv( 'REMOTE_ADDR' );
		$user = &JFactory::getUser();
		if ($action == null) {
			$action = $this->getActionType();
		}
			
		# Check if this user has voted before
		if ( $user->id == 0 ) {
			$lastValidLogDate = $this->lastValidLogDate();
			$vote_ip = getenv( 'REMOTE_ADDR' );
			$query =  "SELECT log_date FROM #__ldlog "
				."WHERE link_id ='".$id."' AND log_ip = '".$vote_ip."' AND log_type = '$action' AND '$lastValidLogDate' < log_date" ;
		} else {
			$query =  "SELECT log_date FROM #__ldlog " 
				. "WHERE link_id ='".$id."' AND user_id = '".$user->id."' AND log_type = '$action'" ;
		}
		$amount = $this->_getListCount($query);
		if (!$amount){
			$this->setError($this->_db->getErrorMsg());
		} 
		$voted = ($amount) ? true : false;
		return $voted;
	}
}

?>